/*
  Copyright (C) 1998-1999 Johan Redestig

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "stdafx.h"
#include "BigBmpPainter.h"
#include "MenuItem.h"
#include "../lsapi/lsapi.h"

int BigBmpPainter::m_nBlt = BMPPAINT_PLAIN;

BigBmpPainter::BigBmpPainter(HBITMAP hBmp)
{
  GetObject(hBmp, sizeof(m_Bmp), &m_Bmp); 

	m_hPicture = CreateCompatibleDC(NULL);
	SelectObject(m_hPicture, hBmp);
	m_hBmp = hBmp;
}

BigBmpPainter::~BigBmpPainter()
{
	DeleteObject(m_hPicture);
	DeleteObject(m_hBmp);
}

void BigBmpPainter::Paint(MenuItem* pMenuItem, HDC hDC)
{
	RECT rcMenu;
	Painter::Paint(pMenuItem, hDC);
	pMenuItem->GetItemRect(&rcMenu);

  HRGN hClipRgn = CreateRectRgn(rcMenu.left, rcMenu.top, rcMenu.right, rcMenu.bottom);
  SelectClipRgn(hDC, hClipRgn);

  int nHeight = rcMenu.bottom - rcMenu.top;
  int nWidth  = rcMenu.right - rcMenu.left;

  int nYPos = rcMenu.top;
  int nXPos = rcMenu.left;

  int nXSrc = (nXPos % m_Bmp.bmWidth);
  int nYSrc = (nYPos % m_Bmp.bmHeight);

  while (nYPos < rcMenu.bottom)
  {
    while (nXPos < rcMenu.right)
    {
      BitBlt(hDC, nXPos, nYPos, nWidth, nHeight, m_hPicture, nXSrc, nYSrc, SRCCOPY);
      nXPos += m_Bmp.bmWidth - nXSrc;
      nXSrc = (nXPos % m_Bmp.bmWidth);
    }
    nYPos += m_Bmp.bmHeight - nYSrc;
    nYSrc = (nYPos % m_Bmp.bmHeight);
    nXPos = 0;
    nXSrc = 0;
    
  }
  

  SelectClipRgn(hDC, NULL);

  DeleteObject(hClipRgn);

}
